# Lab4 - Linux Device Driver
_Alessio Carpegna and Stefano Di Carlo_

## Exercise 1
Write a character device driver for an external component composed of three controllable LEDs.
Refer to the https://sysprog21.github.io/lkmpg/

### LED Specifications

- **LED1** – Blink rate (8-bit)  
- **LED2** – Blink rate (8-bit)  
- **LED3** – Blink rate (8-bit)  
- **Enable Register** – 8-bit

### Component Overview

The component includes four memory-mapped registers:

- Three 8-bit **blink registers** that set a blink rate for the three LEDs  
- One 8-bit **enable register**

The addresses where the registers are mapped in memory should be hard-coded in the driver using the following `#define`s:

```
#define BLINK_REG1 0xf0080000
#define BLINK_REG2 0xf0080001
#define BLINK_REG3 0xf0080002
#define EN_REG     0xf0080003
```

The enable register dedicates **two bits per LED** (starting from the LSB):

- `00` – LED is **off**  
- `11` – LED is **permanently on**  
- `10` – LED should **blink**

### Driver Requirements

The device driver must provide the following functionalities:

- Initialize the device by:
  - Setting the blink rate of all LEDs to `0`
  - Turning all LEDs off
- Program the blink rate of each LED
- Read the current blink rate of each LED
- Change the status of each LED between on, off, and blinking
- Read the status of each LED

### Hardware Simulation

Since the actual hardware is not available, assume the existence of the following two C functions for reading and writing memory-mapped hardware:

```
READDATAFROMTHEHW(void *address, void *buf, int numbyte);
WRITEDATATOHW(void *address, void *data, int numbyte);
```

To test your driver, implement these functions to simply print a message on the screen.

### Additional requirements

Only one process must be able to open the device and use it.



